Index: /DCWoRMS/branches/coolemall/src/schedframe/resources/computing/Node.java
===================================================================
--- /DCWoRMS/branches/coolemall/src/schedframe/resources/computing/Node.java	(revision 1247)
+++ /DCWoRMS/branches/coolemall/src/schedframe/resources/computing/Node.java	(revision 1247)
@@ -0,0 +1,117 @@
+package schedframe.resources.computing;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Properties;
+
+import schedframe.resources.ResourceStatus;
+import schedframe.resources.StandardResourceType;
+import schedframe.resources.computing.description.ComputingResourceDescription;
+import schedframe.resources.computing.extensions.ExtensionType;
+import schedframe.resources.computing.profiles.energy.EnergyExtension;
+import schedframe.resources.computing.profiles.energy.power.ui.NodePowerInterface;
+import schedframe.resources.computing.properties.NodePropertiesBuilder;
+import schedframe.resources.computing.properties.PropertiesDirector;
+import schedframe.resources.units.Cost;
+import schedframe.resources.units.Memory;
+import schedframe.resources.units.StandardResourceUnitName;
+
+public class Node extends ComputingResource{
+	
+
+	public Node (ComputingResourceDescription resDesc) {
+		super(resDesc);
+		
+		//extensionList.add(new EnergyExtension(this, resDesc.getPowerInterface(), resDesc.getEnergyEstimationPlugin()));
+		//PowerInterface pi = PowerInterfaceFactory.createPowerInterface(this, resDesc.getPowerProfile());
+		//AirThroughputInterface ai = AirThroughputInterfaceFactory.createAirThroughputInterface(this, resDesc.getAirThroughputProfile());
+		//accept(new EnergyExtension(pi, resDesc.getPowerProfile()));
+		//accept(new EnergyExtension(pi, resDesc.getPowerProfile(), ai, resDesc.getAirThroughputProfile()));	
+	}	
+	
+	public NodePowerInterface getPowerInterface(){
+		NodePowerInterface powerInterface = null;
+		if(extensionList.isExtensionAvailable(ExtensionType.ENERGY_EXTENSION)){
+			EnergyExtension ee = (EnergyExtension)extensionList.getExtension(ExtensionType.ENERGY_EXTENSION);
+			powerInterface = (NodePowerInterface)ee.getPowerInterface();
+		}
+		return powerInterface;
+	}
+
+	@SuppressWarnings("unchecked")
+	public List<Processor> getProcessors(){
+		return (List<Processor>) getDescendantsByType(StandardResourceType.Processor);
+	}
+	
+	@SuppressWarnings("unchecked")
+	public List<Processor> getFreeProcessors(){
+		return (List<Processor>) getDescendantsByTypeAndStatus(StandardResourceType.Processor, ResourceStatus.FREE);
+	}
+
+	public List<Core> getCores(){
+		List<Core> cores = new ArrayList<Core>();
+		for(Processor proc: getProcessors()){
+			cores.addAll(proc.getCores());
+		}
+		return cores;
+	}
+
+	public List<Core> getFreeCores(){
+		List<Core> freeCores = new ArrayList<Core>();
+		for(Processor proc: getProcessors()){
+			freeCores.addAll(proc.getFreeCores());
+		}
+		return freeCores;
+	}
+	
+	public int getProcessorsNumber() {
+		return getProcessors().size();
+	}
+
+	public int getFreeProcessorsNumber() {
+		return getFreeProcessors().size();
+	}
+	
+	
+	//MEMORY 
+	public int getFreeMemory() throws NoSuchFieldException {
+		return getMemory().getFreeAmount();
+	}
+	
+	public int getTotalMemory() throws NoSuchFieldException {
+		return getMemory().getAmount();
+	}
+
+	public boolean isMemRequirementSatisfied(int memoryReq) throws NoSuchFieldException {
+		if (getFreeMemory() < memoryReq)
+			return false;
+		return true;
+	}
+	
+	public Memory getMemory() throws NoSuchFieldException {
+		return (Memory) ((ComputingResourceCharacteristics)resourceCharacteristic).getResourceUnit(StandardResourceUnitName.MEMORY);
+	}
+	
+	//COST
+	public int getProcessingCost() throws NoSuchFieldException {
+		return getCost().getAmount();
+	}
+	
+	private Cost getCost() throws NoSuchFieldException {
+		return (Cost) ((ComputingResourceCharacteristics)resourceCharacteristic).getResourceUnit(StandardResourceUnitName.COST);
+	}
+
+	
+	public Properties getProperties(){
+		PropertiesDirector propDirector = new PropertiesDirector();
+		propDirector.setPropertiesBuilder(new NodePropertiesBuilder());
+		propDirector.constructProperties(this);
+		return propDirector.getProperties();
+	}
+	
+	
+	/*private void accept(EnergyExtension e){
+		extensionList.add(e);
+		e.setResource(this);
+	}*/
+}
Index: /DCWoRMS/branches/coolemall/src/schedframe/resources/computing/coolemall/NodeGroup.java
===================================================================
--- /DCWoRMS/branches/coolemall/src/schedframe/resources/computing/coolemall/NodeGroup.java	(revision 1207)
+++ /DCWoRMS/branches/coolemall/src/schedframe/resources/computing/coolemall/NodeGroup.java	(revision 1247)
@@ -4,4 +4,5 @@
 
 import schedframe.resources.StandardResourceType;
+import schedframe.resources.computing.Node;
 import schedframe.resources.computing.ComputingResource;
 import schedframe.resources.computing.Processor;
Index: /DCWoRMS/branches/coolemall/src/schedframe/resources/computing/coolemall/ComputeBox1.java
===================================================================
--- /DCWoRMS/branches/coolemall/src/schedframe/resources/computing/coolemall/ComputeBox1.java	(revision 1207)
+++ /DCWoRMS/branches/coolemall/src/schedframe/resources/computing/coolemall/ComputeBox1.java	(revision 1247)
@@ -4,6 +4,4 @@
 
 import schedframe.resources.CoolEmAllResourceType;
-import schedframe.resources.StandardResourceType;
-import schedframe.resources.computing.ComputingNode;
 import schedframe.resources.computing.Rack;
 import schedframe.resources.computing.description.ComputingResourceDescription;
@@ -19,10 +17,4 @@
 		return (List<NodeGroup>) getDescendantsByType(CoolEmAllResourceType.NodeGroup);
 	}
-	
-	@SuppressWarnings("unchecked")
-	public List<ComputingNode> getNodes(){
-		return (List<ComputingNode>) getDescendantsByType(StandardResourceType.Node);
-	}
-
 
 }
Index: /DCWoRMS/branches/coolemall/src/schedframe/resources/computing/Core.java
===================================================================
--- /DCWoRMS/branches/coolemall/src/schedframe/resources/computing/Core.java	(revision 1207)
+++ /DCWoRMS/branches/coolemall/src/schedframe/resources/computing/Core.java	(revision 1247)
@@ -28,12 +28,12 @@
 	}
 	
-	public ComputingNode getNode(){
+	public Node getNode(){
 		ComputingResource compRes = parent;
 		while(compRes != null && !compRes.getType().equals(StandardResourceType.Node)){
 			compRes = compRes.getParent();
 		}
-		ComputingNode compNode = null;
+		Node compNode = null;
 		try{
-			compNode = (ComputingNode)compRes;
+			compNode = (Node)compRes;
 		} catch(ClassCastException e) {
 		}
Index: /DCWoRMS/branches/coolemall/src/schedframe/resources/CoolEmAllResourceFactory.java
===================================================================
--- /DCWoRMS/branches/coolemall/src/schedframe/resources/CoolEmAllResourceFactory.java	(revision 1207)
+++ /DCWoRMS/branches/coolemall/src/schedframe/resources/CoolEmAllResourceFactory.java	(revision 1247)
@@ -1,4 +1,5 @@
 package schedframe.resources;
 
+import schedframe.resources.computing.Node;
 import schedframe.resources.computing.ComputingResource;
 import schedframe.resources.computing.Core;
@@ -7,5 +8,4 @@
 import schedframe.resources.computing.ResourceFactory;
 import schedframe.resources.computing.coolemall.ComputeBox1;
-import schedframe.resources.computing.coolemall.Node;
 import schedframe.resources.computing.coolemall.NodeGroup;
 import schedframe.resources.computing.description.ComputingResourceDescription;
Index: /DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/resources/ClusterResourceManager.java
===================================================================
--- /DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/resources/ClusterResourceManager.java	(revision 1207)
+++ /DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/resources/ClusterResourceManager.java	(revision 1247)
@@ -7,5 +7,5 @@
 import schedframe.exceptions.ResourceException;
 import schedframe.resources.StandardResourceType;
-import schedframe.resources.computing.ComputingNode;
+import schedframe.resources.computing.Node;
 import schedframe.resources.computing.ComputingResource;
 import schedframe.resources.computing.Processor;
@@ -21,9 +21,9 @@
 
 	@SuppressWarnings("unchecked")
-	public List<ComputingNode> getComputingNodes(){
+	public List<Node> getNodes(){
 		try {
-			return (List<ComputingNode>) getResourcesOfType(StandardResourceType.Node);
+			return (List<Node>) getResourcesOfType(StandardResourceType.Node);
 		} catch (ResourceException e) {
-			return new ArrayList<ComputingNode>();
+			return new ArrayList<Node>();
 		}
 	}
@@ -39,7 +39,7 @@
 
 	@SuppressWarnings("unchecked")
-	public List<ComputingNode> getComputingNodes(Properties properties){
+	public List<Node> getNodes(Properties properties){
 		properties.setProperty("type", StandardResourceType.Node.toString());
-		return (List<ComputingNode>) filterResources(properties);
+		return (List<Node>) filterResources(properties);
 
 	}
Index: /DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/resources/ResourceManagerFactory.java
===================================================================
--- /DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/resources/ResourceManagerFactory.java	(revision 1005)
+++ /DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/resources/ResourceManagerFactory.java	(revision 1247)
@@ -1,4 +1,5 @@
 package schedframe.scheduling.manager.resources;
 
+import schedframe.resources.StandardResourceType;
 import schedframe.scheduling.GridResourceDiscovery;
 import schedframe.scheduling.Scheduler;
@@ -10,11 +11,11 @@
 		ManagedComputingResources managedResource = scheduler.getCompResources();
 		
-		if(managedResources == null || managedResource.getType().getName().equals("DataCenter"))
+		if(managedResources == null || managedResource.getType().getName().equals(StandardResourceType.DataCenter))
 			return new GridResourceDiscovery(scheduler);
-		else if (managedResource.getType().getName().equals("Rack"))
+		else if (managedResource.getType().getName().equals(StandardResourceType.Rack))
 			return new ClusterResourceManager(scheduler.getCompResources(), scheduler.getChildren(), managedResources);
-		else if (managedResource.getType().getName().equals("ComputingNode"))
+		else if (managedResource.getType().getName().equals(StandardResourceType.Node))
 			return new ClusterResourceManager(scheduler.getCompResources(), scheduler.getChildren(), managedResources);
-		else if (managedResource.getType().getName().equals("Processor"))
+		else if (managedResource.getType().getName().equals(StandardResourceType.Processor))
 			return new ClusterResourceManager(scheduler.getCompResources(), scheduler.getChildren(), managedResources);
 		else return new ClusterResourceManager(scheduler.getCompResources(), scheduler.getChildren(), managedResources);
